stop/restart servoy server by terminal

Questions and Answers on installation, deployment, management, locking, tranasactions of Servoy Application Server

stop/restart servoy server by terminal

Postby tgs » Mon Sep 17, 2012 12:44 pm

Hi,

how can I stop/restart the Servoy App server by Terminal?
I couldn't find any function in the wiki.

Regards,
Thomas Schnaus
SAN Developer
yomotec GmbH
User avatar
tgs
 
Posts: 886
Joined: Wed Oct 04, 2006 12:05 pm
Location: Germany

Re: stop/restart servoy server by terminal

Postby ngervasi » Mon Sep 17, 2012 1:14 pm

On Linux you have to create a init.d script for that, on MacOS you can use Lingon.
Which platform are you using?
Nicola Gervasi
sintpro.com
SAN Partner
ngervasi
 
Posts: 1485
Joined: Tue Dec 21, 2004 12:47 pm
Location: Arezzo, Italy

Re: stop/restart servoy server by terminal

Postby tgs » Mon Sep 17, 2012 7:23 pm

Hi Nicola,

I would like to have it for both, Mac OS X and Linux.

Does the init.d script for Linux than work like:
Code: Select all
./etc/init.d/servoy_server start/stop/restart
?

A script example would be very appreciate.

Regards,
Thomas Schnaus
SAN Developer
yomotec GmbH
User avatar
tgs
 
Posts: 886
Joined: Wed Oct 04, 2006 12:05 pm
Location: Germany

Re: stop/restart servoy server by terminal

Postby ngervasi » Mon Sep 17, 2012 7:28 pm

Here's the init.d script for Ubuntu/Debian, you just need to define the USER and HOME variables in the beginning of the script and install it for the desired runlevels:

Code: Select all
#! /bin/sh
### BEGIN INIT INFO
# Provides:          Servoy Server
# Required-Start:    $local_fs $remote_fs
# Required-Stop:     $local_fs $remote_fs
# Default-Start:     2 3 4 5
# Default-Stop:      S 0 1 6
# Short-Description: Servoy Server Startup Script
# Description:       This file starts the Servoy Server
### END INIT INFO

# Author: Nicola Gervasi <nick@sintpro.com>

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/usr/sbin:/usr/bin:/sbin:/bin
DESC="Servoy Server"
USER=servoy
HOME=/home/servoy/servoy/application_server
NAME=servoy_server.sh
DAEMON=$HOME/$NAME
DAEMON_ARGS=""
PIDFILE=$HOME/servoy.pid
SCRIPTNAME=/etc/init.d/servoy

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
   # Return
   #   0 if daemon has been started
   #   1 if daemon was already running
   #   2 if daemon could not be started
   start-stop-daemon --start --quiet  --pidfile $PIDFILE --chuid $USER --chdir $HOME \
      --make-pidfile --background --exec $DAEMON --$DAEMON_ARGS
   
   # Add code here, if necessary, that waits for the process to be ready
   # to handle requests from services started subsequently which depend
   # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
   # Return
   #   0 if daemon has been stopped
   #   1 if daemon was already stopped
   #   2 if daemon could not be stopped
   #   other if a failure occurred
   start-stop-daemon --stop --quiet --retry=TERM/5/KILL/5 \
      --user $USER --name "java" --oknodo
   RETVAL="$?"
   [ "$RETVAL" = 2 ] && return 2
   # Many daemons don't delete their pidfiles when they exit.
   rm -f $PIDFILE
   return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
   #
   # If the daemon can reload its configuration without
   # restarting (for example, when it is sent a SIGHUP),
   # then implement that here.
   #
   start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
   return 0
}

case "$1" in
  start)
   [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
   do_start
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  stop)
   [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
   do_stop
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  #reload|force-reload)
   #
   # If do_reload() is not implemented then leave this commented out
   # and leave 'force-reload' as an alias for 'restart'.
   #
   #log_daemon_msg "Reloading $DESC" "$NAME"
   #do_reload
   #log_end_msg $?
   #;;
  restart|force-reload)
   #
   # If the "reload" option is implemented then remove the
   # 'force-reload' alias
   #
   log_daemon_msg "Restarting $DESC" "$NAME"
   do_stop
   case "$?" in
     0|1)
      do_start
      case "$?" in
         0) log_end_msg 0 ;;
         1) log_end_msg 1 ;; # Old process is still running
         *) log_end_msg 1 ;; # Failed to start
      esac
      ;;
     *)
        # Failed to stop
      log_end_msg 1
      ;;
   esac
   ;;
  *)
   #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
   echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
   exit 3
   ;;
esac

:


For MacOS download Lingon, it's pretty straight forward.
Nicola Gervasi
sintpro.com
SAN Partner
ngervasi
 
Posts: 1485
Joined: Tue Dec 21, 2004 12:47 pm
Location: Arezzo, Italy

Re: stop/restart servoy server by terminal

Postby tgs » Mon Sep 17, 2012 7:34 pm

Cool! Thank you very much Nicola!
Thomas Schnaus
SAN Developer
yomotec GmbH
User avatar
tgs
 
Posts: 886
Joined: Wed Oct 04, 2006 12:05 pm
Location: Germany

Re: stop/restart servoy server by terminal

Postby tgs » Tue Sep 18, 2012 12:45 pm

Hi Nicola,

I have created the script file "servoy" in the directory /etc/init.d on my Debian 6 system like your example.
I also defined the variables USER and HOME and set the permissions to executable, but it doesn't work.
If I make a restart of the Server, Servoy App Server doesn't start by init.d (note: The PostgreSQL Server is starting/stopping/restarting by its init.d script). In the logfiles I couldn't find anything about.

Do you have any idea what could be wrong?

Regards,
Thomas Schnaus
SAN Developer
yomotec GmbH
User avatar
tgs
 
Posts: 886
Joined: Wed Oct 04, 2006 12:05 pm
Location: Germany

Re: stop/restart servoy server by terminal

Postby ngervasi » Tue Sep 18, 2012 12:51 pm

Did you run the "update-rc.d" command to install the script in the desired runlevels? Check update-rc.d man page for details.
If that doesn't fix it let me know which error you get when you run sudo /etc/init.d/servoy start.
Nicola Gervasi
sintpro.com
SAN Partner
ngervasi
 
Posts: 1485
Joined: Tue Dec 21, 2004 12:47 pm
Location: Arezzo, Italy

Re: stop/restart servoy server by terminal

Postby tgs » Tue Sep 18, 2012 1:25 pm

I have tied to install the script into the runlevels by "update-rc.d" and I get:
Code: Select all
administrator@debian-6-server:/etc/init.d$ sudo update-rc.d servoy defaults
[sudo] password for administrator:
update-rc.d: using dependency based boot sequencing
update-rc.d: warning: servoy start runlevel arguments (2 3 4 5) do not match LSB Default-Start values (     2 3 4 5)
update-rc.d: warning: servoy stop runlevel arguments (0 1 6) do not match LSB Default-Stop values (      S 0 1 6)
insserv: Script servoy is broken: incomplete LSB comment.
insserv: missing valid name for `Provides:' please add.


I can set the startup item to enabled with "rcconf". But this is what I get in the Terminal if I try to start the Servoy server:
Code: Select all
administrator@debian-6-server:~$ sudo /etc/init.d/servoy start
/etc/init.d/servoy: 71: Syntax error: Unterminated quoted string


And if I check if the startup item is installed by "sudo ls -l /etc/rc?.d/servoy" I get that it is not found.
Thomas Schnaus
SAN Developer
yomotec GmbH
User avatar
tgs
 
Posts: 886
Joined: Wed Oct 04, 2006 12:05 pm
Location: Germany

Re: stop/restart servoy server by terminal

Postby ngervasi » Tue Sep 18, 2012 1:35 pm

It works in Ubuntu just fine, probably your Debian expects a slightly different syntax when installing.
Just change the following lines (6 and 7) with the runlevels that update-rc.d expects:

Code: Select all
# Default-Start:     2 3 4 5
# Default-Stop:      S 0 1 6


I checked line 71 and it's just a plain comment:
Code: Select all
# Many daemons don't delete their pidfiles when they exit.


I checked around that line and I don't see any "Unterminated quoted string", Can you double check the code? Maybe some quotes got corrupted from copy paste?
Nicola Gervasi
sintpro.com
SAN Partner
ngervasi
 
Posts: 1485
Joined: Tue Dec 21, 2004 12:47 pm
Location: Arezzo, Italy

Re: stop/restart servoy server by terminal

Postby tgs » Tue Sep 18, 2012 2:38 pm

Hi Nicola,

I have formatted the script in the Terminal editor (nano) because of possible errors occurred by copy/paste, and now I get no more errors about this.
The startup item should now set correctly because there are entries of "servoy" in the /etc/rc*.d/. But now it comes:
Code: Select all
administrator@debian-6-server:~$ sudo /etc/init.d/servoy start
start-stop-daemon: unrecognized option '--quiet '
Try 'start-stop-daemon --help' for more information.
/etc/init.d/servoy: 141:  : not found


Ok, the daemon don't like the "--quiet" option and I have removed it in the codelines. Now the finally error is "/etc/init.d/servoy: 141:  : not found" (line 141 is now the last of the script!).
Here is my modified script:
Code: Select all
#! /bin/sh
### BEGIN INIT INFO
# Provides:Servoy Server
# Required-Start:$local_fs $remote_fs
# Required-Stop:$local_fs $remote_fs
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Servoy Server Startup Script
# Description: This file starts the Servoy Server
### END INIT INFO

# Author: Nicola Gervasi <nick@sintpro.com>

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/usr/sbin:/usr/bin:/sbin:/bin
DESC="Servoy Server"
USER=administrator
HOME=/home/administrator/servoy6/application_server
NAME=servoy_server.sh
DAEMON=$HOME/$NAME
DAEMON_ARGS=""
PIDFILE=$HOME/servoy.pid
SCRIPTNAME=/etc/init.d/servoy

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        start-stop-daemon --start --pidfile $PIDFILE --chuid $USER --chdir $HOME \ --make-pidfile --background --exec $$
   
        # Add code here, if necessary, that waits for the process to be ready
        # to handle requests from services started subsequently which depend
        # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
        # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        start-stop-daemon --stop --retry=TERM/5/KILL/5 \ --user $USER --name "java" --oknodo
        RETVAL="$?"
        [ "$RETVAL" = 2 ] && return 2
        # Many daemons do not delete their pidfiles when they exit.
        rm -f $PIDFILE
        return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload()
{
        #
        # If the daemon can reload its configuration without
        # restarting for example, when it is sent a SIGHUP,
        # then implement that here.
        #
        start-stop-daemon --stop --signal 1 --pidfile $PIDFILE --name $NAME
        return 0
}

case "$1" in
        start)
        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
        do_start
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
        stop)
        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        do_stop
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
        #reload|force-reload)
        #
        # If do_reload is not implemented then leave this commented out
        # and leave 'force-reload' as an alias for 'restart'.
        #
        #log_daemon_msg "Reloading $DESC" "$NAME"
        #do_reload
        #log_end_msg $?
        #;;
        restart|force-reload)
        #
        # If the "reload" option is implemented then remove the
        # 'force-reload' alias
        #
        log_daemon_msg "Restarting $DESC" "$NAME"
        do_stop
        case "$?" in
                0|1)
                do_start
        case "$?" in
                0) log_end_msg 0 ;;
                1) log_end_msg 1 ;; # Old process is still running
                *) log_end_msg 1 ;; # Failed to start
        esac
        ;;
        *)
                # Failed to stop
                log_end_msg 1
        ;;
        esac
        ;;
        *)
        #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
        echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
        exit 3
        ;;
esac


**EDIT**
The Servoy App Server is now starting automatically on reboot of the Debian server, but the manual restart/stop function will not work.
Code: Select all
sudo /etc/init.d/servoy restart
Restarting Servoy Server: servoy_server.sh/etc/init.d/servoy: 141:  : not found
failed!


Regards and once more thank you Nicola,
Thomas Schnaus
SAN Developer
yomotec GmbH
User avatar
tgs
 
Posts: 886
Joined: Wed Oct 04, 2006 12:05 pm
Location: Germany

Re: stop/restart servoy server by terminal

Postby ngervasi » Tue Sep 18, 2012 4:04 pm

You're welcome.
About the error: you are missing a semicolon, this is how the file should end:

Code: Select all
        #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
        echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
        exit 3
        ;;
esac

:


Don't fotget the last semicolon!
Nicola Gervasi
sintpro.com
SAN Partner
ngervasi
 
Posts: 1485
Joined: Tue Dec 21, 2004 12:47 pm
Location: Arezzo, Italy

Re: stop/restart servoy server by terminal

Postby tgs » Tue Sep 18, 2012 4:59 pm

Hi Nicola,

I have added the ":" (doublecolon? I think semicolon is a ";", or?) on the end of the script.
Now it is working. I can start/stop/restart(*) the servoy server by "sudo /etc/init.d/servoy (*)", but only on stop I get no error.

Anyway, it's doing what it should do and I will investigate a little bit more the script code and the way I have installed/configured it.
You helped me a lot and I could save time to get it working only by myself.

Regards,
Thomas Schnaus
SAN Developer
yomotec GmbH
User avatar
tgs
 
Posts: 886
Joined: Wed Oct 04, 2006 12:05 pm
Location: Germany

Re: stop/restart servoy server by terminal

Postby ngervasi » Tue Sep 18, 2012 6:13 pm

Woops, I was in a hurry, it's a "colon" (:) not a "semicolon" (;).

Glad to have helped.
Nicola Gervasi
sintpro.com
SAN Partner
ngervasi
 
Posts: 1485
Joined: Tue Dec 21, 2004 12:47 pm
Location: Arezzo, Italy


Return to Servoy Server

Who is online

Users browsing this forum: No registered users and 6 guests